;========================================================================================
;  crtmodtest.s
;  Copyright (C) 2003-2023 Makoto Kamada
;
;  This file is part of the XEiJ (X68000 Emulator in Java).
;  You can use, modify and redistribute the XEiJ if the conditions are met.
;  Read the XEiJ License for more details.
;  https://stdkmd.net/xeij/
;========================================================================================

	.include	bioswork.equ
	.include	control2.mac
	.include	doscall.mac
	.include	iocscall.mac
	.include	misc.mac
	.include	push2.mac
	.include	sprc.equ
	.include	sram.equ

TITLE_STRING	reg	'CRTMODTEST for IPLROM 1.6 (2023-11-15)'

	.text

;IvVmF
	moveq.l	#-1,d6			;CRT/LCD͎w肳ĂȂ
	moveq.l	#-1,d7			;ʃ[h͎w肳ĂȂ
	sf.b	save_to_sram		;CRT/LCDSRAMɕۑȂ
	lea.l	1(a2),a0
	dostart
		gotoand	<cmp.b #'-',d0>,ne,<cmp.b #'/',d0>,ne,usage_exit	;-,/ȊO
		addq.l	#1,a0
		move.b	(a0)+,d0
		goto	eq,usage_exit		;-,/̌ɕȂ
		bsr	tolower
		if	<cmp.b #'l',d0>,eq	;-l
			goto	<tst.l d6>,pl,usage_exit	;CRT/LCD͊Ɏw肳Ă
			bsr	nonspace
			bsr	stou
			gotoor	<>,cs,<cmp.l #1,d0>,hi,usage_exit	;10iȂ͈͊O
			move.l	d0,d6			;CRT/LCDw肳ꂽ
		elif	<cmp.b #'m',d0>,eq	;-m
			goto	<tst.l d7>,pl,usage_exit	;ʃ[h͊Ɏw肳Ă
			bsr	nonspace
			bsr	stou
			gotoor	<>,cs,<cmp.l #39,d0>,hi,usage_exit	;10iȂ͈͊O
			move.l	d0,d7			;ʃ[hw肳ꂽ
		elif	<cmp.b #'s',d0>,eq	;-s
			st.b	save_to_sram		;CRT/LCDSRAMɕۑ
		else				;-l,-m,-sȊO
			goto	usage_exit
		endif
	start
		bsr	nonspace
	while	ne
	goto	<tst.l d7>,mi,usage_exit	;ʃ[hw肳ĂȂ
	gotoand	<tst.l d6>,mi,<tst.b save_to_sram>,ne,usage_exit	;CRT/LCDw肳ĂȂ̂SRAMɕۑłȂ
;<d6.l:0=CRT,1=LCD,-1=w肳ĂȂ
;<d7.l:ʃ[h

	supervisormode

;CRT/LCDۑ
	btst.b	#SRAM_XEIJ_LCD_BIT,SRAM_XEIJ
	sne.b	saved_crtlcd

;ʃ[hݒ肷
	move.l	d7,d1			;ʃ[h
	if	<tst.l d6>,pl		;LCD[hw肳Ă
		if	eq			;CRT
			or.w	#$4300,d1
		else				;LCD
			or.w	#$4C00,d1
		endif
	endif
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON

;W
	moveq.l	#0,d0
	move.b	BIOS_CRTMOD.w,d0
	move.l	d0,crtmod

	moveq.l	#0,d0
	if	<btst.b #SRAM_XEIJ_LCD_BIT,SRAM_XEIJ>,ne
		moveq.l	#1,d0
	endif
	move.l	d0,crtlcd

	moveq.l	#0,d0
	move.w	BIOS_GRAPHIC_RIGHT.w,d0
	addq.l	#1,d0
	moveq.l	#0,d1
	move.w	BIOS_CONSOLE_RIGHT.w,d1
	addq.w	#1,d1
	lsl.w	#3,d1
	if	<cmp.l d1,d0>,lo
		move.l	d1,d0
	endif
	move.l	d0,width

	moveq.l	#0,d0
	move.w	BIOS_GRAPHIC_BOTTOM.w,d0
	addq.l	#1,d0
	moveq.l	#0,d1
	move.w	BIOS_CONSOLE_BOTTOM.w,d1
	addq.w	#1,d1
	lsl.w	#4,d1
	if	<cmp.l d1,d0>,lo
		move.l	d1,d0
	endif
	move.l	d0,height

	moveq.l	#0,d0
	move.l	BIOS_GRAPHIC_Y_OFFSET.w,d0
	lsr.l	#1,d0
	move.l	d0,size

	moveq.l	#0,d0
	move.w	BIOS_GRAPHIC_PALETS.w,d0
	addq.l	#1,d0
	move.l	d0,palets

	moveq.l	#0,d0
	move.b	BIOS_GRAPHIC_PAGES.w,d0
	move.l	d0,pages

	move.w	SPRC_RESOLUTION,d0
	if	<btst.l #0,d0>,eq
		move.l	#0,bgsize
	else
		move.l	#1,bgsize
	endif

	usermode

;`

TEXT_LINE	equ	3
GRAPHIC_LINE	equ	4
SPRITE_LINE	equ	8
BG0_LINE	equ	9
BG1_LINE	equ	10

;F
	sethsv	TEXT_COLOR,0,24,31
	sethsv	GRAPHIC_0_COLOR,24,24,31
	sethsv	GRAPHIC_1_COLOR,48,24,31
	sethsv	GRAPHIC_2_COLOR,72,24,31
	sethsv	GRAPHIC_3_COLOR,96,24,31
	sethsv	SPRITE_COLOR,120,24,31
	sethsv	BG0_COLOR,144,24,31
	sethsv	BG1_COLOR,168,24,31

;eLXg
	moveq.l	#3,d1			;pbgR[h
	move.w	#TEXT_COLOR,d2		;J[R[h
	IOCS	_TPALET

	lea.l	string_buffer,a0
	leastrdata	'CRTMOD(',a1
	bsr	strcpy
	move.l	crtmod,d0
	bsr	utos
	if	<tst.l crtlcd>,eq
		leastrdata	') CRT',a1
	else
		leastrdata	') LCD',a1
	endif
	bsr	strcpy
	moveq.l	#3,d1			;J[R[h
	moveq.l	#2,d2			;XW
	moveq.l	#1,d3			;YW
	lea.l	string_buffer,a1	;
	move.l	a0,d4
	sub.l	a1,d4
	subq.w	#1,d4			;-1
	IOCS	_B_PUTMES

	lea.l	string_buffer,a0
	move.l	width,d0
	bsr	utos
	leastrdata	'x',a1
	bsr	strcpy
	move.l	height,d0
	bsr	utos
	leastrdata	'/',a1
	bsr	strcpy
	move.l	size,d0
	bsr	utos
	leastrdata	'x',a1
	bsr	strcpy
	move.l	size,d0
	bsr	utos
	leastrdata	' ',a1
	bsr	strcpy
	move.l	palets,d0
	bsr	utos
	leastrdata	' ',a1
	bsr	strcpy
	move.l	pages,d0
	bsr	utos
	moveq.l	#3,d1			;J[R[h
	moveq.l	#2,d2			;XW
	moveq.l	#2,d3			;YW
	lea.l	string_buffer,a1	;
	move.l	a0,d4
	sub.l	a1,d4
	subq.w	#1,d4			;-1
	IOCS	_B_PUTMES

	moveq.l	#3,d1			;J[R[h
	moveq.l	#2,d2			;XW
	moveq.l	#TEXT_LINE,d3		;YW
	moveq.l	#8-1,d4			;-1
	leastrdata	'sdws',a1		;
	IOCS	_B_PUTMES

;OtBbN
	if	<cmp.l #65536,palets>,lo

		moveq.l	#0,d1			;pbgR[h
		move.w	#0,d2			;J[R[h
		IOCS	_GPALET

		moveq.l	#1,d1			;pbgR[h
		move.w	#GRAPHIC_0_COLOR,d2	;J[R[h
		IOCS	_GPALET

		moveq.l	#2,d1			;pbgR[h
		move.w	#GRAPHIC_1_COLOR,d2	;J[R[h
		IOCS	_GPALET

		moveq.l	#3,d1			;pbgR[h
		move.w	#GRAPHIC_2_COLOR,d2	;J[R[h
		IOCS	_GPALET

		moveq.l	#4,d1			;pbgR[h
		move.w	#GRAPHIC_3_COLOR,d2	;J[R[h
		IOCS	_GPALET

	endif

	if	<cmpi.l #1,pages>,hs

		move.w	#$FFFF,-(sp)		;CX^C
		if	<cmp.l #65536,palets>,lo
			move.w	#1,-(sp)		;pbgR[h
		else
			move.w	#GRAPHIC_0_COLOR,-(sp)	;J[R[h
		endif
		move.l	height,d0
		subq.w	#1,d0
		move.w	d0,-(sp)		;I_YW
		move.l	width,d0
		subq.w	#1,d0
		move.w	d0,-(sp)		;I_XW
		clr.w	-(sp)			;n_YW
		clr.w	-(sp)			;n_XW
		movea.l	sp,a1
		IOCS	_BOX
		lea.l	12(sp),sp

		moveq.l	#0,d1
		IOCS	_APAGE
		move.w	#1<<8|0,-(sp)		;TCY,px
		if	<cmp.l #65536,palets>,lo
			move.w	#1,-(sp)		;pbgR[h
		else
			move.w	#GRAPHIC_0_COLOR,-(sp)	;J[R[h
		endif
		move.w	#1<<8|1,-(sp)		;X̔{,Y̔{
		peastrdata	'fq`oghb@o`fd@O'	;
		move.w	#16*(GRAPHIC_LINE+0),-(sp)	;YW
		move.w	#8*2,-(sp)		;XW
		movea.l	sp,a1
		IOCS	_SYMBOL
		lea.l	14(sp),sp
	endif

	if	<cmpi.l #2,pages>,hs
		moveq.l	#1,d1
		IOCS	_APAGE
		move.w	#1<<8|0,-(sp)		;TCY,px
		move.w	#2,-(sp)		;pbgR[h
		move.w	#1<<8|1,-(sp)		;X̔{,Y̔{
		peastrdata	'fq`oghb@o`fd@P'	;
		move.w	#16*(GRAPHIC_LINE+1),-(sp)	;YW
		move.w	#8*2,-(sp)		;XW
		movea.l	sp,a1
		IOCS	_SYMBOL
		lea.l	14(sp),sp
	endif

	if	<cmpi.l #4,pages>,hs
		moveq.l	#2,d1
		IOCS	_APAGE
		move.w	#1<<8|0,-(sp)		;TCY,px
		move.w	#3,-(sp)		;pbgR[h
		move.w	#1<<8|1,-(sp)		;X̔{,Y̔{
		peastrdata	'fq`oghb@o`fd@Q'	;
		move.w	#16*(GRAPHIC_LINE+2),-(sp)	;YW
		move.w	#8*2,-(sp)		;XW
		movea.l	sp,a1
		IOCS	_SYMBOL
		lea.l	14(sp),sp
		moveq.l	#3,d1
		IOCS	_APAGE
		move.w	#1<<8|0,-(sp)		;TCY,px
		move.w	#4,-(sp)		;pbgR[h
		move.w	#1<<8|1,-(sp)		;X̔{,Y̔{
		peastrdata	'fq`oghb@o`fd@R'	;
		move.w	#16*(GRAPHIC_LINE+3),-(sp)	;YW
		move.w	#8*2,-(sp)		;XW
		movea.l	sp,a1
		IOCS	_SYMBOL
		lea.l	14(sp),sp
	endif

;XvCg
	IOCS	_SP_INIT
	if	<tst.l d0>,eq		;XvCg\\

		IOCS	_SP_ON

		moveq.l	#0,d1			;pbgR[h
		moveq.l	#1,d2			;pbgubN
		move.w	#0,d3			;J[R[h
		IOCS	_SPALET

		moveq.l	#15,d1			;pbgR[h
		moveq.l	#1,d2			;pbgubN
		move.w	#SPRITE_COLOR,d3	;J[R[h
		IOCS	_SPALET

		moveq.l	#0,d1			;pbgR[h
		moveq.l	#2,d2			;pbgubN
		move.w	#0,d3			;J[R[h
		IOCS	_SPALET

		moveq.l	#15,d1			;pbgR[h
		moveq.l	#2,d2			;pbgubN
		move.w	#BG0_COLOR,d3		;J[R[h
		IOCS	_SPALET

		moveq.l	#0,d1			;pbgR[h
		moveq.l	#3,d2			;pbgubN
		move.w	#0,d3			;J[R[h
		IOCS	_SPALET

		moveq.l	#15,d1			;pbgR[h
		moveq.l	#3,d2			;pbgubN
		move.w	#BG1_COLOR,d3		;J[R[h
		IOCS	_SPALET

		moveq.l	#2,d1			;p^[ԍ
		moveq.l	#1,d2			;16x16
		lea.l	sprite_pattern,a1
		IOCS	_SP_DEFCG

;				  3 4 5 6 7 8 910111213141516171819202122
		leastrdata	'roqhsda`bj|fqntmc@OP',a2
		moveq.l	#3,d6			;p^[ԍ
		moveq.l	#0,d1
		move.b	(a2)+,d1		;R[h
		while	ne
			lsl.w	#8,d1
			move.b	(a2)+,d1		;R[h
			moveq.l	#8,d2			;16x16
			lea.l	font_buffer,a1
			IOCS	_FNTGET

			lea.l	pattern_buffer,a0
			lea.l	font_buffer+4,a1
			moveq.l	#16-1,d3
			for	d3
				moveq.l	#0,d0
				move.b	(a1)+,d1
				addq.l	#1,a1
				moveq.l	#8-1,d2
				for	d2
					lsl.l	#4,d0
					add.b	d1,d1
					if	cs
						add.b	#15,d0
					endif
				next
				move.l	d0,(a0)+
			next
			lea.l	font_buffer+4,a1
			moveq.l	#16-1,d3
			for	d3
				moveq.l	#0,d0
				addq.l	#1,a1
				move.b	(a1)+,d1
				moveq.l	#8-1,d2
				for	d2
					lsl.l	#4,d0
					add.b	d1,d1
					if	cs
						add.b	#15,d0
					endif
				next
				move.l	d0,(a0)+
			next

			move.w	d6,d1			;p^[ԍ
			moveq.l	#1,d2			;16x16
			lea.l	pattern_buffer,a1
			IOCS	_SP_DEFCG

			addq.w	#1,d6			;p^[ԍ

			moveq.l	#0,d1
			move.b	(a2)+,d1		;R[h
		endwhile

		moveq.l	#0,d1			;XvCgԍ
		moveq.l	#16,d2			;XW
		moveq.l	#16,d3			;YW
		move.w	#1<<8|2,d4		;pbgubN<<8|p^[ԍ
		moveq.l	#3,d5			;vCIeB
		IOCS	_SP_REGST

		moveq.l	#1,d1			;XvCgԍ
		move.l	width,d2		;XW
		moveq.l	#16,d3			;YW
		move.w	#1<<8|2,d4		;pbgubN<<8|p^[ԍ
		moveq.l	#3,d5			;vCIeB
		IOCS	_SP_REGST

		moveq.l	#2,d1			;XvCgԍ
		moveq.l	#16,d2			;XW
		move.l	height,d3		;YW
		move.w	#1<<8|2,d4		;pbgubN<<8|p^[ԍ
		moveq.l	#3,d5			;vCIeB
		IOCS	_SP_REGST

		moveq.l	#3,d1			;XvCgԍ
		move.l	width,d2		;XW
		move.l	height,d3		;YW
		move.w	#1<<8|2,d4		;pbgubN<<8|p^[ԍ
		moveq.l	#3,d5			;vCIeB
		IOCS	_SP_REGST

;				 S P R I T E
		leastrdata	<3,4,5,6,7,8>,a2	;p^[ԍ
		moveq.l	#4,d7			;XvCgԍ
		movea.w	#16+16*1,a3		;XW
		movea.w	#16+16*SPRITE_LINE,a4	;YW
		moveq.l	#0,d0
		move.b	(a2)+,d0		;p^[ԍ
		while	ne
			move.l	d7,d1			;XvCgԍ
			move.w	a3,d2			;XW
			move.w	a4,d3			;YW
			move.w	#1<<8,d4		;pbgubN<<8
			move.b	d0,d4			;p^[ԍ
			moveq.l	#3,d5			;vCIeB
			IOCS	_SP_REGST

			addq.w	#1,d7			;XvCgԍ

			adda.w	#16,a3			;XW

			moveq.l	#0,d0
			move.b	(a2)+,d0		;R[h
		endwhile

		if	<tst.l bgsize>,eq	;BGp^[8x8ABGzʂ512x512

			moveq.l	#2,d1			;p^[ԍ
			moveq.l	#0,d2			;TCY
			lea.l	bg0_pattern,a1
			IOCS	_SP_DEFCG

			moveq.l	#3,d1			;p^[ԍ
			moveq.l	#0,d2			;TCY
			lea.l	bg1_pattern,a1
			IOCS	_SP_DEFCG

			moveq.l	#0,d1			;BGy[W
			moveq.l	#0,d2			;BGeLXgGA
			moveq.l	#1,d3			;\ON
			IOCS	_BGCTRLST

			moveq.l	#1,d1			;BGy[W
			moveq.l	#1,d2			;BGeLXgGA
			moveq.l	#1,d3			;\ON
			IOCS	_BGCTRLST

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#0<<8|0,d2		;pbgubN<<8|p^[ԍ
			IOCS	_BGTEXTCL

			moveq.l	#1,d1			;BGeLXgGA
			move.w	#0<<8|0,d2		;pbgubN<<8|p^[ԍ
			IOCS	_BGTEXTCL

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#2<<8|2,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#0,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#3,d7
			subq.w	#1,d7
			for	d7
				moveq.l	#0,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#3,d6
				subq.w	#1,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#0<<8|0,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#1,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#3,d7
			subq.w	#3,d7
			for	d7
				moveq.l	#1,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#3,d6
				subq.w	#3,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

			moveq.l	#1,d1			;BGeLXgGA
			move.w	#3<<8|3,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#0,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#3,d7
			subq.w	#1,d7
			for	d7
				moveq.l	#0,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#3,d6
				subq.w	#1,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

			moveq.l	#1,d1			;BGeLXgGA
			move.w	#0<<8|0,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#1,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#3,d7
			subq.w	#3,d7
			for	d7
				moveq.l	#1,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#3,d6
				subq.w	#3,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

;					 B  A  C  K  -  G  R  O  U  N  D     0
			leastrdata	<9,10,11,12,13,14,15,16,17,18,19,20,21>,a2	;p^[ԍ
			moveq.l	#0,d1			;BGeLXgGA
			movea.w	#2*1,a3			;XW
			movea.w	#2*BG0_LINE,a4		;YW
			moveq.l	#0,d0
			move.b	(a2)+,d0		;p^[ԍ
			while	ne
				move.w	#2<<8,d4	;pbgubN<<8
				move.b	d0,d4		;p^[ԍ
				lsl.b	#2,d4

				move.w	a3,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				addq.w	#1,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				addq.w	#1,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				addq.w	#1,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				addq.w	#1,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#2,a3		;BGeLXgXW

				moveq.l	#0,d0
				move.b	(a2)+,d0	;p^[ԍ
			endwhile

;					 B  A  C  K  -  G  R  O  U  N  D     1
			leastrdata	<9,10,11,12,13,14,15,16,17,18,19,20,22>,a2	;p^[ԍ
			moveq.l	#1,d1			;BGeLXgGA
			movea.w	#2*1,a3			;XW
			movea.w	#2*BG1_LINE,a4		;YW
			moveq.l	#0,d0
			move.b	(a2)+,d0		;p^[ԍ
			while	ne
				move.w	#3<<8,d4	;pbgubN<<8
				move.b	d0,d4		;p^[ԍ
				lsl.b	#2,d4

				move.w	a3,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				addq.w	#1,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				addq.w	#1,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				addq.w	#1,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				addq.w	#1,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#2,a3		;BGeLXgXW

				moveq.l	#0,d0
				move.b	(a2)+,d0	;p^[ԍ
			endwhile

		else				;BGp^[16x16ABGzʂ1024x1024ABG0̂

			moveq.l	#1,d1			;p^[ԍ
			moveq.l	#1,d2			;16x16
			lea.l	bg_pattern,a1
			IOCS	_SP_DEFCG

			moveq.l	#0,d1			;BGy[W
			moveq.l	#0,d2			;BGeLXgGA
			moveq.l	#1,d3			;\ON
			IOCS	_BGCTRLST

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#0<<8|0,d2		;pbgubN<<8|p^[ԍ
			IOCS	_BGTEXTCL

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#2<<8|1,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#0,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#4,d7
			subq.w	#1,d7
			for	d7
				moveq.l	#0,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#4,d6
				subq.w	#1,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

			moveq.l	#0,d1			;BGeLXgGA
			move.w	#0<<8|0,d4		;pbgubN<<8|p^[ԍ
			moveq.l	#1,d3			;BGeLXgYW
			move.l	height,d7
			lsr.w	#4,d7
			subq.w	#3,d7
			for	d7
				moveq.l	#1,d2			;BGeLXgXW
				move.l	width,d6
				lsr.w	#4,d6
				subq.w	#3,d6
				for	d6
					IOCS	_BGTEXTST
					addq.w	#1,d2			;BGeLXgXW
				next
				addq.w	#1,d3			;BGeLXgYW
			next

;					 B  A  C  K  -  G  R  O  U  N  D     0
			leastrdata	<9,10,11,12,13,14,15,16,17,18,19,20,21>,a2	;p^[ԍ
			moveq.l	#0,d1			;BGeLXgGA
			movea.w	#1*1,a3			;XW
			movea.w	#1*BG0_LINE,a4		;YW
			moveq.l	#0,d0
			move.b	(a2)+,d0		;p^[ԍ
			while	ne
				move.w	#2<<8,d4	;pbgubN<<8
				move.b	d0,d4		;p^[ԍ

				move.w	a3,d2		;BGeLXgXW
				move.w	a4,d3		;BGeLXgYW
				IOCS	_BGTEXTST

				addq.w	#1,a3		;BGeLXgXW

				moveq.l	#0,d0
				move.b	(a2)+,d0	;p^[ԍ
			endwhile

		endif

	endif

;L[͂҂Ăʃ[h𕜌
;	ESCL[ꂽƂ͕Ȃ
	IOCS	_B_CUROFF
	DOS	_GETC
	if	<cmp.b #27,d0>,ne
		if	<tst.b save_to_sram>,eq	;CRT/LCDSRAMɕۑȂ
			if	<tst.b saved_crtlcd>,eq	;CRT
				move.w	#$43FF,d1
			else				;LCD
				move.w	#$4CFF,d1
			endif
			IOCS	_CRTMOD			;CRT/LCD𕜌
		endif
		move.l	#(16<<16)|$FFFF,-(sp)
		DOS	_CONCTRL
		move.w	d0,2(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
	endif
	IOCS	_B_CURON

;I
exit:
	DOS	_EXIT

;^CgƎgp@\ďI
usage_exit:
	lea.l	title_usage(pc),a0
	bsr	more
	goto	exit

;^CgƎgp@
title_usage:
	.dc.b	TITLE_STRING,13,10
	.dc.b	'IvV',13,10
	.dc.b	'  -l 0-1   0=CRT,1=LCD',13,10
	.dc.b	'  -m 0-39  ʃ[h',13,10
	.dc.b	'  -s       CRT/LCDSRAMɕۑ',13,10
	.dc.b	'  ',13,10
	.dc.b	'  CRTMODʃTCY F y[W            ʃTCY      l      ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     0   1024x1024     16  1                                                        ',13,10
	.dc.b	'     4    512x512      16  4    CRT  31.500kHz  55.458Hz   512x512                  ',13,10
	.dc.b	'     8    512x512     256  2    LCD  35.341kHz  56.546Hz   512x512                  ',13,10
	.dc.b	'    12    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     1   1024x1024     16  1                                                        ',13,10
	.dc.b	'     5    512x512      16  4    CRT  15.980kHz  61.463Hz   512x480   C^[[X ',13,10
	.dc.b	'     9    512x512     256  2    LCD  35.341kHz  56.546Hz   512x480                  ',13,10
	.dc.b	'    13    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     2   1024x1024     16  1                                                        ',13,10
	.dc.b	'     6    512x512      16  4    CRT  31.500kHz  55.458Hz   256x256   X^xǂ ',13,10
	.dc.b	'    10    512x512     256  2    LCD  34.500kHz  55.200Hz   256x256   X^xǂ ',13,10
	.dc.b	'    14    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'     3   1024x1024     16  1                                                        ',13,10
	.dc.b	'     7    512x512      16  4    CRT  15.980kHz  61.463Hz   256x240                  ',13,10
	.dc.b	'    11    512x512     256  2    LCD  34.500kHz  55.200Hz   256x240   X^xǂ ',13,10
	.dc.b	'    15    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    16   1024x1024     16  1    CRT  31.500kHz  55.458Hz   768x512                  ',13,10
	.dc.b	'    20    512x512     256  2    LCD  35.056kHz  56.090Hz   768x512                  ',13,10
	.dc.b	'    24    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    17   1024x1024     16  1    CRT  24.699kHz  53.116Hz  1024x424                  ',13,10
	.dc.b	'    21    512x512     256  2    LCD  35.056kHz  56.090Hz   768x600                  ',13,10
	.dc.b	'    25    512x512   65536  1                                 ό`                   ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    18   1024x1024     16  1    CRT  24.699kHz  53.116Hz  1024x848   C^[[X ',13,10
	.dc.b	'    22    512x512     256  2    LCD  35.056kHz  56.090Hz   768x1024  C^[[X ',13,10
	.dc.b	'    26    512x512   65536  1                                 ό`                   ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    19   1024x1024     16  1    CRT  31.500kHz  55.458Hz   640x480   VGAł͂Ȃ    ',13,10
	.dc.b	'    23    512x512     256  2    LCD  31.469kHz  59.940Hz   640x480   VGA            ',13,10
	.dc.b	'    27    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    28   1024x1024     16  1                                                        ',13,10
	.dc.b	'    29    512x512      16  4    CRT  31.963kHz  56.273Hz   384x256   X^xǂ ',13,10
	.dc.b	'    30    512x512     256  2    LCD  31.963kHz  51.141Hz   384x256   X^xǂ ',13,10
	.dc.b	'    31    512x512   65536  1                                                        ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    32   1024x1024     16  1                                                        ',13,10
	.dc.b	'    33    512x512      16  4    CRT  31.500kHz  55.458Hz   512x512                  ',13,10
	.dc.b	'    34    512x512     256  2    LCD  35.056kHz  56.090Hz   512x512                  ',13,10
	.dc.b	'    35    512x512   65536  1                                `                  ',13,10
	.dc.b	'  ',13,10
	.dc.b	'    36   1024x1024     16  1                                                        ',13,10
	.dc.b	'    37    512x512      16  4    CRT  31.963kHz  56.273Hz   256x256   X^xǂ ',13,10
	.dc.b	'    38    512x512     256  2    LCD  31.963kHz  51.141Hz   256x256   X^xǂ ',13,10
	.dc.b	'    39    512x512   65536  1                                `                  ',13,10
	.dc.b	'  ',13,10
	.dc.b	0
	.even

bg0_pattern:
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000

bg1_pattern:
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$FF00FF00
	.dc.l	$FF00FF00
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$FF00FF00
	.dc.l	$FF00FF00

bg_pattern:
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000

	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000
	.dc.l	$00FF00FF
	.dc.l	$00FF00FF
	.dc.l	$00000000
	.dc.l	$00000000

sprite_pattern:
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000

	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$0000FFFF
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000
	.dc.l	$FFFF0000

;----------------------------------------------------------------
;-more-݂Ȃ當\
;<a0.l:
more:
	push	d0-d5/a0-a2
;W͂mF
	clr.l	-(sp)			;(0<<16)|0
	DOS	_IOCTRL
	addq.l	#4,sp
;<d0.b:W͂FCBtO
	and.b	#$81,d0			;LN^foCXAW
	goto	<cmp.b #$81,d0>,ne,90f	;W͂_CNgĂBmoreȂ
;Wo͂mF
	pea.l	1.w			;(0<<16)|1
	DOS	_IOCTRL
	addq.l	#4,sp
;<d0.b:Wo͂FCBtO
	and.b	#$82,d0			;LN^foCXAWo
	goto	<cmp.b #$82,d0>,ne,90f	;Wo͂_CNgĂBmoreȂ
;CONDRV.SYSmF
	move.w	#$0100+_KEY_INIT,-(sp)
	DOS	_INTVCG
	addq.l	#2,sp
	movea.l	d0,a1
	subq.l	#4,a1
	IOCS	_B_LPEEK
	goto	<cmp.l #'hmk*',d0>,eq,90f	;CONDRV.SYSgݍ܂ĂBmoreȂ
;ʂ̑傫mF
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	IOCS	_B_CONSOL
;<d2.l:E[̌W<<16|[̍sW
	move.w	d2,d3
	swap.w	d2
	addq.w	#1,d2
;<d2.w:ʂ̌
;<d3.w:[̍sWB-more-̍sʂ̍s
	gotoor	<cmp.w #8,d2>,lo,<tst.w d3>,eq,90f	;ʂBmoreȂB^u܂߂1ȏ㏑Ȃ΂ȂȂ̂8x1s
;y[W[v
	do
		move.l	#0,d4			;W
		move.l	#0,d5			;sW
		movea.l	a0,a2			;y[W擪
	;[v
		do
			movea.l	a0,a1			;擪
			move.b	(a0)+,d0		;1oCg
			if	eq			;00 I
				subq.l	#1,a0
				break
			elif	<cmp.b #$09,d0>,eq	;09 ^u
				moveq.l	#7,d1
				and.w	d4,d1
				subq.w	#8,d1
				neg.w	d1		;^ǔ
			elif	<cmp.b #$0A,d0>,eq	;0A s
				moveq.l	#0,d4		;[
				addq.w	#1,d5		;̍s
				break	<cmp.w d3,d5>,eq	;[By[WI
				continue
			elif	<cmp.b #$0C,d0>,eq	;0C y[W
				break
			elif	<cmp.b #$1F,d0>,ls	;01-08,0B,0D-1F 
				continue
			else				;20-FF
				do
					moveq.l	#1,d1			;p̌
					break	<tst.b d0>,pl		;20-7F AXL[
					breakand	<cmp.b #$A0,d0>,hs,<cmp.b #$DF,d0>,ls	;A0-DF pJ^Ji
					addq.l	#1,a0			;2oCg
					break	<cmp.b #$80,d0>,eq	;8000-80FF pЂ炪
					break	<cmp.b #$F0,d0>,hs	;F000-FFFF 1/4pApO
					moveq.l	#2,d1			;Sp̌
				while	f
			endif
			add.w	d1,d4			;\̌W
			if	<cmp.w d2,d4>,hi	;͂ݏo
				sub.w	d1,d4			;i݉߂߂
				movea.l	a1,a0
				addq.w	#1,d5			;̍s
				break	<cmp.w d3,d5>,eq	;[By[WI
				moveq.l	#0,d4			;[
			endif
		while	t
	;1y[W\
		move.l	a0,d0			;
		sub.l	a2,d0			;-擪=
		move.l	d0,-(sp)		;
		move.l	a2,-(sp)		;擪
		move.w	#1,-(sp)		;Wo
		DOS	_WRITE
		lea.l	10(sp),sp
	;ȂΏI
		break	<tst.b (a0)>,eq
	;KvȂΉs
		ifand	<tst.w d4>,ne,<cmp.w d2,d4>,ne	;[łE[łȂ
			bsr	printcrlf
		endif
	;-more-\
		pea.l	6.w
		pea.l	100f(pc)		;'-more-'
		move.w	#1,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
	;L[͂҂
		DOS	_GETC
		move.l	d0,d1
	;s
		bsr	printcrlf
	whileand	<cmp.b #$1B,d1>,ne,<cmp.b #'Q',d1>,ne,<cmp.b #'q',d1>,ne	;ESC܂QꂽƂ͏I
99:	pop
	rts

;moreȂ
90:	bsr	print
	goto	99b

100:	.dc.b	'-more-'
	.even

;----------------------------------------------------------------
;󔒈ȊO̕܂œǂݔ΂
;<a0.l:
;>d0.l:󔒈ȊO̕܂0
;>a0.l:󔒈ȊO̕܂0̈ʒu
;>z:eq=0
nonspace:
	moveq.l	#0,d0
	do
		move.b	(a0)+,d0		;̕
		redoand	<cmp.b #9,d0>,hs,<cmp.b #13,d0>,ls	;\t\n\v\f\rȂΌJԂ
	while	<cmp.b #' ',d0>,eq	;󔒂ȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	tst.l	d0
	rts

;----------------------------------------------------------------
;\
;<a0.l:
print:
	move.l	d0,-(sp)
	bsr	strlen
	move.l	d0,-(sp)
	move.l	a0,-(sp)
	move.w	#1,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;s\
printcrlf:
	move.l	a0,-(sp)
	lea.l	100f(pc),a0		;13,10
	bsr	print
	movea.l	(sp)+,a0
	rts

100:	.dc.b	13,10,0
	.even

;----------------------------------------------------------------
;10i̕𕄍Ȃɕϊ
;<a0.l:10i̕B擪̋󔒂͔F߂Ȃ
;>d0.l:(cĉƂ)ȂB(cŝƂ)0=10i̕Ȃ,-1=I[o[t[
;>a0.l:(cĉƂ)10i̎̈̕ʒuB(cŝƂ)ωȂ
;>z:(cĉƂ)eq=Ȃ0
;>v:(cŝƂ)vc=10i̕Ȃ,vs=I[o[t[
;>c:cs=10i̕Ȃ܂̓I[o[t[
stou:
	push	d1-d2/a1
	moveq.l	#0,d0			;Ȃ
	moveq.l	#0,d1			;
	movea.l	a0,a1			;Jnʒu
	dostart
		goto	<cmp.l #$1999999A,d0>,hs,80f	;10{I[o[t[
		move.l	d0,d2			;1{
		lsl.l	#2,d0			;4{
		add.l	d2,d0			;5{
		add.l	d0,d0			;10{
		add.l	d1,d0			;1
		goto	cs,80f			;I[o[t[
	start
		move.b	(a0)+,d1		;̕
		sub.b	#'0',d1			;ɂ
	whileand	<>,hs,<cmp.b #10,d1>,lo	;10i̕ȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	if	<cmpa.l a1,a0>,eq	;iłȂB10i̕Ȃ
		move.w	#%00001,ccr		;vc,cs
	else
		tst.l	d0			;eq or ne,vc,cc
	endif
	goto	90f

;I[o[t[Ƃ
80:	moveq.l	#-1,d0			;I[o[t[
	movea.l	a1,a0			;ωȂ
	move.w	#%00011,ccr		;vs,cs
90:	pop
	rts

;----------------------------------------------------------------
;Rs[
;<a0.l:Rs[
;<a1.l:Rs[
;>a0.l:Rs[0̈ʒu
;>a1.l:Rs[0̎̈ʒu
strcpy:
	do
		move.b	(a1)+,(a0)+
	while	ne			;0łȂΌJԂ
	subq.l	#1,a0			;i݉߂߂
	rts

;----------------------------------------------------------------
;̒𐔂
;<a0.l:
;>d0.l:
strlen:
	move.l	a0,d0			;d0=擪
	do
		tst.b (a0)+
	while	ne			;0łȂΌJԂ
	subq.l	#1,a0			;i݉߂߂Ba0=
	exg.l	d0,a0			;d0=,a0=擪
	sub.l	a0,d0			;d0=-擪=
	rts

;----------------------------------------------------------------
;ɂ
;<d0.b:
;>d0.b:
tolower:
	ifand	<cmp.b #'A',d0>,hs,<cmp.b #'Z',d0>,ls	;啶
		add.b	#'a'-'A',d0		;ɂ
	endif
	rts

;----------------------------------------------------------------
;啶ɂ
;<d0.b:
;>d0.b:
toupper:
	ifand	<cmp.b #'a',d0>,hs,<cmp.b #'z',d0>,ls	;
		add.b	#'A'-'a',d0		;啶ɂ
	endif
	rts

;----------------------------------------------------------------
;Ȃ10i̕ɕϊ
;<d0.l:Ȃ
;<a0.l:obt@
;>a0.l:obt@0̈ʒu
utos:
	push	d0-d2/a1
	if	<tst.l d0>,eq		;0
		move.b	#'0',(a0)+
	else				;0ȊO
		lea.l	100f(pc),a1
		do
			move.l	(a1)+,d1
		while	<cmp.l d1,d0>,lo	;Ƃ܂ŐiށB[TvX
		do
			moveq.l	#'0'-1,d2
			do
				addq.b	#1,d2
				sub.l	d1,d0
			while	hs			;ȂȂ܂ŌJԂ
			add.l	d1,d0			;߂߂
			move.b	d2,(a0)+
			move.l	(a1)+,d1
		while	ne
	endif
	clr.b	(a0)
	pop
	rts

100:	.dc.l	1000000000
	.dc.l	100000000
	.dc.l	10000000
	.dc.l	1000000
	.dc.l	100000
	.dc.l	10000
	.dc.l	1000
	.dc.l	100
	.dc.l	10
	.dc.l	1
	.dc.l	0



	.bss

save_to_sram:
	.ds.b	1
saved_crtlcd:
	.ds.b	1
	.even
crtmod:
	.ds.l	1
crtlcd:
	.ds.l	1
width:
	.ds.l	1
height:
	.ds.l	1
size:
	.ds.l	1
pages:
	.ds.l	1
palets:
	.ds.l	1
bgsize:
	.ds.l	1
font_buffer:
	.ds.w	1
	.ds.w	1
	.ds.b	3*24
pattern_buffer:
	.ds.l	8*4
string_buffer:
	.ds.b	256

	.end
